## mingw-w64-python-polars-1.36.1-2.src.tar.zst

=== py-polars/docs/Makefile ===
# Minimal makefile for Sphinx documentation

ifeq ($(shell uname),Darwin)
export OBJC_DISABLE_INITIALIZE_FORK_SAFETY=YES
endif
export BUILDING_SPHINX_DOCS = 1

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -j auto -W
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

clean:
	@rm -rf source/reference/*/api/
	@rm -rf source/reference/api/
	@rm -rf "$(BUILDDIR)"

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=polars
pkgbase=mingw-w64-python-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-python-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-python-${_realname}-runtime-64")
pkgver=1.36.1
pkgrel=2
pkgdesc="Extremely fast Query Engine for DataFrames, written in Rust (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.pola.rs/'
msys2_repository_url='https://github.com/pola-rs/polars'
license=('spdx:MIT')
msys2_references=(
  'archlinux: python-polars'
  'anitya: 179760'
  'purl: pkg:pypi/polars'
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-rust"
  "${MINGW_PACKAGE_PREFIX}-maturin"
  "${MINGW_PACKAGE_PREFIX}-python-installer"
  "${MINGW_PACKAGE_PREFIX}-python-build"
  "${MINGW_PACKAGE_PREFIX}-python-wheel"
  "${MINGW_PACKAGE_PREFIX}-python-setuptools"
  "${MINGW_PACKAGE_PREFIX}-sed"
  'git'
)
options=('!strip' '!lto')
source=("${msys2_repository_url}/archive/py-${pkgver}/${_realname}-py-${pkgver}.tar.gz")
noextract=("${_realname}-py-${pkgver}.tar.gz")
sha256sums=('a7fc1221cfb7c77a1fbc346a7b3ca20ef37cb25bafea5dbb5b8e8ddf23e3aa0d')

prepare() {
  tar -xf "${_realname}-py-${pkgver}.tar.gz" || true

  cd "${_realname}-py-${pkgver}/py-polars"

  cp ../LICENSE .
  cp ../rust-toolchain.toml .

  sed -i 's/polars-runtime-32/polars-runtime-64/g' pyproject.toml

  cargo fetch \
    --locked \
    --config='net.git-fetch-with-cli=true' \
    --target "${RUST_CHOST}"
}

build() {
  cd "${_realname}-py-${pkgver}/py-polars"

  export _PYTHON_HOST_PLATFORM=$(python -c "import sysconfig, sys; sys.stdout.write(sysconfig.get_platform())")
  export WINAPI_NO_BUNDLED_LIBRARIES=1
  python -m build --wheel --no-isolation
  maturin build -o dist --release --locked --strip \
   --no-default-features --features full \
   --compatibility linux \
   --manifest-path runtime/polars-runtime-64/Cargo.toml 
}

package_python-polars() {
  cd "${_realname}-py-${pkgver}/py-polars"

  depends=(
    "${MINGW_PACKAGE_PREFIX}-python"
    "${MINGW_PACKAGE_PREFIX}-python-numpy"
    "${MINGW_PACKAGE_PREFIX}-python-polars-runtime-64"
  )
  optdepends=(
    "${MINGW_PACKAGE_PREFIX}-python-pandas: for interoperability with pandas frames"
    "${MINGW_PACKAGE_PREFIX}-python-pyarrow: for interoperability with arrow types"
    "${MINGW_PACKAGE_PREFIX}-python-pytz: to enable conversion to python datetimes with timezones"
    "${MINGW_PACKAGE_PREFIX}-python-fastexcel: for reading excel workbooks"
    #"${MINGW_PACKAGE_PREFIX}-python-fsspec: to transparently open files locally or remotely"
  )

  python -m installer -d "$pkgdir" ./dist/polars-*.whl

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" ./dist/polars-*.whl

  install -Dm0644 LICENSE -t "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}/"

  # Remove duplicate files (for more info see https://github.com/msys2/MINGW-packages/pull/26356)
  cd "${pkgdir}"
  for _df in $(ls | grep -v ${MINGW_PREFIX/\//}); do rm -rf $_df; done
}

package_python-polars-runtime-64() {
  cd "${_realname}-py-${pkgver}/py-polars"

  pkgdesc+=" (native runtime libraries)"
  depends=("${MINGW_PACKAGE_PREFIX}-python")

  MSYS2_ARG_CONV_EXCL="--prefix=" \
    python -m installer --prefix=${MINGW_PREFIX} \
    --destdir="${pkgdir}" ./dist/polars_runtime*.whl

  install -Dm0644 LICENSE -t "${pkgdir}${MINGW_PREFIX}/share/licenses/python-${_realname}-runtime-64/"
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
